<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>IoT Net</title>
</head>

<body>
  <form>
    <fieldset>
      <legend>Devices Control</legend>
      <div id="devicesRadioList">
        <!--
          <div id="MAC"><label><input type="radio" name="mac" value="{MAC}" />MAC</label></div>
          -->
      </div>
      <br>
      <button type="button" id="toggle_led_button" disabled="disabled">Toggle LED</button>
      <p id="output"></p>
    </fieldset>
  </form>
  <div id="database">
  <p>Latest Data</p>
    <ul id="data"></ul>
  </div>
  <fieldset>
    <legend>Data Visualization</legend>
    <label for="start">Start date:</label>
    <input type="date" id="start_date" name="start" value="2022-11-13" min="2022-11-12">
    <label for="start">End date:</label>
    <input type="date" id="end_date" name="end" value="2022-11-16" min="2022-11-16"><br><br>
    <div id="devicesCheckbox">
    </div><br>
    <div id="units">
    </div><br>
    <button type="button" id="submit_date">Submit</button>
    <div class="canvas">
      <canvas id="line_canvas" height="500px">[No canvas support]</canvas>
    </div>
  </fieldset>
  <script src='https://code.jquery.com/jquery-3.4.1.js'></script>
  <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
  <!--Imports jquery-->
  <script src="/socket.io/socket.io.js"></script>
  <!--Imports socket io-->
  <script>
    const units = {
      t: " \u2103",
      h: " %",
      p: " Bar",
    }
    var socket = io();
    let selectedMac;

    //Chart configuration
    const line_data = {
      labels: [],
      datasets: []
    };

    const config = {
      type: 'line',
      data: line_data,
      options: {
        maintainAspectRatio: false,
        scales: {
          yAxes: {
            type: 'linear',
          },
        },
        showLines: true
      }
    };
    const chart = new Chart($('#line_canvas'), config)

    function getCheckboxValues(elements) {
      checkedCheckboxes = [];
      for (var checkbox of elements) {  
        if (checkbox.checked)  
          checkedCheckboxes.push(checkbox.value);
      }
      return checkedCheckboxes;
    }

    //Submits data query selectors to the backend
    $('#submit_date').click(() => {
      var selectors = {};
      selectors['MAC'] = getCheckboxValues($('#devicesCheckbox *'));
      if (!selectors.MAC.length) { alert('ERROR: No device selected'); return; }
      selectors['unit'] = getCheckboxValues($('#units *'));
      if (!selectors.unit.length) { alert('ERROR: No unit selected'); return; }
      selectors['startDate'] = $('#start_date').prop("valueAsNumber");
      selectors['endDate'] = $('#end_date').prop("valueAsNumber");
      socket.emit("canvas", selectors)
    });

    $('#toggle_led_button').click(() => {
        console.log("Toggle LED:" + selectedMac)
        socket.emit("toggle_led", selectedMac);//Sends the 'toggle_led' event to the backend
    });

    function addRadioButton(mac) {
      console.log("Added: ", mac);
      //Adds new DOM elements to the radio button div
      $('#devicesRadioList').append($('<div id="' + mac + '"><label><input type="radio" name="mac" value=' + mac + ' />' + mac + '</label><br></div>'));
      //Event - Is triggered when a radio button change occours
      $('input[type=radio][name=mac]').change(function () {
        console.log("Selected: " + this.value);
        selectedMac = this.value;
        $("#toggle_led_button").prop("disabled", false);
      });
    }

    //Default Socket IO connect event
    socket.on("connect", () => {
      $('#data').html('');//Resets the DB entries list
      $('#devicesCheckbox').html('');
      $('#units').html('');
    });

    //Occours if the python script disconnects - Resets the radio button list
    socket.on("python_disconnect", () => {
      $('#devicesRadioList').html('');
      $("#toggle_led_button").prop("disabled", true);
      $('#output').text('PYTHON SCRIPT DISCONNECTED')
    });

    socket.on('init', (network_devices, legacy_entries) => {
      network_devices.forEach(mac => {
        addRadioButton(mac)
      });
      //Iterates the legacy entries and appends them
      for (const object in legacy_entries) {
        for (const key in legacy_entries[object]) {
          if (object == 'MAC') {
            $('#devicesCheckbox').append($('<input type="checkbox" id=' + key + ' value=' + key + '>'));
            $('#devicesCheckbox').append($('<label for=' + key + '>' + key + '</label>'));
          }
          else if (object == 'unit') {
            value = legacy_entries[object][key];
            $('#units').append($('<input type="checkbox" id=' + key + ' value=' + key + '>'));
            $('#units').append($('<label for=' + key + '>' + value + '</label>'));
          }
        }
      }
    });

    socket.on('device_added', (mac) => {
      addRadioButton(mac);
    });

    socket.on('device_removed', (mac) => {
      console.log("Removed: ", mac);
      //If the device removed was the currently selected one then disable the button
      if (mac == selectedMac) $("#toggle_led_button").prop("disabled", true);
      $('#' + mac).remove();
    });

    //Firebase DB -> Socket IO - Init DB childs on connect
    socket.on('init_child', function (data) {
      if (data.unit == 'p') data.value /= 100000; //Converts to bar
      $('#data').append($('<li id=' + data.MAC + data.unit + '>' + data.MAC + ": " + data.value + units[data.unit] + '</li>'));
    });

    //Firebase DB -> Socket IO - New DB child is added
    socket.on('new_child', function (data) {
      elements = $("#" + data.MAC + data.unit);
      if (elements.length != 0) { //If the key/id associated with the child exists then update it
        $('#' + data.MAC + data.unit).text(data.MAC + ": " + data.value + units[data.unit]);
      }
      else { //If the key/id associated with the child doesn't exists then append it
        $('#data').append($('<li id=' + data.MAC + data.unit + '>' + data.MAC + ": " + data.value + units[data.unit] + '</li>'));
      }
    });

    //Firebase DB -> Socket IO - A DB child was deleted
    socket.on('deleted_child', function (data, key) {
    
    });

    //Occours when query selectors has been submitted and
    //the backend returns the quried data
    socket.on("canvas_data", (data, startDate, endDate) => {
      if (jQuery.isEmptyObject(data))
      {
        alert('No data available');
        return;
      }
      chart.data.datasets = [];
      chart.data.labels = [];
      var labels_length = 0;
      let i = 0;
      //Iterates the data - See the format in app.js
      for (const mac in data) {
        for (const unit in data[mac]) {
          chart.data.datasets[i] = {}; //Init a JS object
          chart.data.datasets[i].label = String(mac + " " + units[unit]); //Sets the line label
          chart.data.datasets[i].data = data[mac][unit]; //Sets the data points for the line
          if (chart.data.datasets[i].data.length > labels_length)
            labels_length = data[mac][unit].length; //Gets the longest data array - Used for adding labels
          i++; //Counts the amount of datasets - One dataset for each unit for each mac/device
        }
      }
      //Cheap way of adding labels - Definitely not accurate
      timePeriod = endDate - startDate;
      timeInterval = timePeriod / labels_length;
      for (let _i = startDate; _i < endDate; _i += timeInterval)
      {
        var dt = new Date(_i*1000).toLocaleString('en-UK');
        chart.data.labels.push(dt);
      }
      chart.update();
    });

    //Jquery event - Fires when all DOM elements are loaded
    $(document).ready(() => {
    });
  </script>
</body>

</html>